import { useEffect, useLayoutEffect, useState } from "react";
import SeatLayout from "../components/top-level/seat-layout";
import { useAppContext } from "../_context";
import { useNavigate } from "react-router-dom";
import { bookingSeats } from "./seed";

export function _Seatlayout() {
  let { userseats, AddOrUpdateSeats, GetAllSeats } = useAppContext();
  const [reservedSeat, setReservedSeat] = useState([]);
  const [selectedSeat, setSelectedSeat] = useState([]);
  const [seatLimit, setSeatLimit] = useState(0);
  const navigate = useNavigate();
  const userId = sessionStorage.getItem("userId");

  useEffect(() => {
    handleReservedSeats();
  }, [userseats]);
  useLayoutEffect(() => {
    GetAllSeats();
  }, []);

  const handleReservedSeats = async () => {
    let seatArray = [];
    const reservedSeats = userseats?.filter((e) => e.id != userId);
    reservedSeats.forEach((element) => {
      element.seats.forEach((e) => {
        seatArray = [...seatArray, e];
        setReservedSeat(seatArray);
      });
    });
    const selectedSeats = await userseats?.find((e) => e.id == userId);
    const results = selectedSeats?.seats;
    setSelectedSeat(results);
    const sessionSeatLimit = sessionStorage.getItem("seatLimit");
    setTimeout(() => {
      sessionStorage.setItem("seatLimit", sessionSeatLimit ?? results?.length);
      setSeatLimit(sessionStorage.getItem("seatLimit"));
    }, 500);
  };

  const handleConfirmed = async ({ id, seats }) => {
    await AddOrUpdateSeats({ id, seats });
    sessionStorage.setItem("currentPath", "/confirmation");
    navigate("/confirmation", { state: { seats: seats } });
  };

  return (
    <SeatLayout
      userId={userId}
      seatLimit={seatLimit}
      seats={bookingSeats}
      selectedSeats={selectedSeat}
      reservedSeats={reservedSeat}
      onClick={handleConfirmed}
    />
  );
}
